Index: uspace/lib/libc/include/rwlock.h
===================================================================
--- uspace/lib/libc/include/rwlock.h	(revision 7fff5eab4db78f93413ceae2f73966e318e1a0aa)
+++ uspace/lib/libc/include/rwlock.h	(revision 67f63c47e41903200a85cbc1871d6437a812e285)
@@ -49,8 +49,8 @@
 
 #define rwlock_initialize(rwlock)	futex_initialize((rwlock), 1)
-#define rwlock_reader_lock(rwlock)	futex_down((rwlock))
-#define rwlock_writer_lock(rwlock)	futex_down((rwlock))
-#define rwlock_reader_unlock(rwlock)	futex_up((rwlock))
-#define rwlock_writer_unlock(rwlock)	futex_up((rwlock))
+#define rwlock_read_lock(rwlock)	futex_down((rwlock))
+#define rwlock_write_lock(rwlock)	futex_down((rwlock))
+#define rwlock_read_unlock(rwlock)	futex_up((rwlock))
+#define rwlock_write_unlock(rwlock)	futex_up((rwlock))
 
 #endif
Index: uspace/srv/vfs/vfs_mount.c
===================================================================
--- uspace/srv/vfs/vfs_mount.c	(revision 7fff5eab4db78f93413ceae2f73966e318e1a0aa)
+++ uspace/srv/vfs/vfs_mount.c	(revision 67f63c47e41903200a85cbc1871d6437a812e285)
@@ -186,5 +186,5 @@
 		 * We already have the root FS.
 		 */
-		rwlock_writer_lock(&namespace_rwlock);
+		rwlock_write_lock(&namespace_rwlock);
 		rc = vfs_lookup_internal(buf, size, &mp, &mpsz, NULL);
 		if (rc != EOK) {
@@ -192,5 +192,5 @@
 			 * The lookup failed for some reason.
 			 */
-			rwlock_writer_unlock(&namespace_rwlock);
+			rwlock_write_unlock(&namespace_rwlock);
 			futex_up(&rootfs_futex);
 			vfs_node_put(mr_node);	/* failed -> drop reference */
@@ -201,5 +201,5 @@
 		mp_node = vfs_node_get(&mp, mpsz);
 		if (!mp_node) {
-			rwlock_writer_unlock(&namespace_rwlock);
+			rwlock_write_unlock(&namespace_rwlock);
 			futex_up(&rootfs_futex);
 			vfs_node_put(mr_node);	/* failed -> drop reference */
@@ -213,5 +213,5 @@
 		 * This prevents the mount point from being deleted.
 		 */
-		rwlock_writer_unlock(&namespace_rwlock);
+		rwlock_write_unlock(&namespace_rwlock);
 	} else {
 		/*
Index: uspace/srv/vfs/vfs_open.c
===================================================================
--- uspace/srv/vfs/vfs_open.c	(revision 7fff5eab4db78f93413ceae2f73966e318e1a0aa)
+++ uspace/srv/vfs/vfs_open.c	(revision 67f63c47e41903200a85cbc1871d6437a812e285)
@@ -94,5 +94,5 @@
 	 * triplet.
 	 */
-	rwlock_reader_lock(&namespace_rwlock);
+	rwlock_read_lock(&namespace_rwlock);
 
 	/*
@@ -103,5 +103,5 @@
 	rc = vfs_lookup_internal(path, len, &triplet, &size, NULL);
 	if (rc) {
-		rwlock_reader_unlock(&namespace_rwlock);
+		rwlock_read_unlock(&namespace_rwlock);
 		ipc_answer_0(rid, rc);
 		free(path);
@@ -115,5 +115,5 @@
 
 	vfs_node_t *node = vfs_node_get(&triplet, size);
-	rwlock_reader_unlock(&namespace_rwlock);
+	rwlock_read_unlock(&namespace_rwlock);
 
 	/*
Index: uspace/srv/vfs/vfs_rdwr.c
===================================================================
--- uspace/srv/vfs/vfs_rdwr.c	(revision 7fff5eab4db78f93413ceae2f73966e318e1a0aa)
+++ uspace/srv/vfs/vfs_rdwr.c	(revision 67f63c47e41903200a85cbc1871d6437a812e285)
@@ -94,7 +94,7 @@
 	 */
 	if (read)
-		rwlock_reader_lock(&file->node->contents_rwlock);
+		rwlock_read_lock(&file->node->contents_rwlock);
 	else
-		rwlock_writer_lock(&file->node->contents_rwlock);
+		rwlock_write_lock(&file->node->contents_rwlock);
 
 	int fs_phone = vfs_grab_phone(file->node->fs_handle);	
@@ -129,9 +129,9 @@
 	 */
 	if (read)
-		rwlock_reader_unlock(&file->node->contents_rwlock);
+		rwlock_read_unlock(&file->node->contents_rwlock);
 	else {
 		/* Update the cached version of node's size. */
 		file->node->size = IPC_GET_ARG2(answer); 
-		rwlock_writer_unlock(&file->node->contents_rwlock);
+		rwlock_write_unlock(&file->node->contents_rwlock);
 	}
 
@@ -197,7 +197,7 @@
 	}
 	if (whence == SEEK_END) {
-		rwlock_reader_lock(&file->node->contents_rwlock);
+		rwlock_read_lock(&file->node->contents_rwlock);
 		size_t size = file->node->size;
-		rwlock_reader_unlock(&file->node->contents_rwlock);
+		rwlock_read_unlock(&file->node->contents_rwlock);
 		if (size + off < size) {
 			futex_up(&file->lock);