Index: uspace/lib/c/include/adt/int_map.h
===================================================================
--- uspace/lib/c/include/adt/int_map.h	(revision aaa3f33ad2cc7b8a1f42205ed0c585a630c45481)
+++ uspace/lib/c/include/adt/int_map.h	(revision 70ce016acff7f538ed8a3c5f6d5e388857608868)
@@ -56,5 +56,7 @@
 #define INT_MAP_DECLARE(name, type) \
 	typedef	struct name name##_t; \
+	typedef	name##_t *name##_ref; \
 	typedef	struct name##_item name##_item_t; \
+	typedef	name##_item_t *name##_item_ref; \
 	\
 	struct	name##_item { \
@@ -67,21 +69,21 @@
 		int size; \
 		int next; \
-		name##_item_t *items; \
+		name##_item_ref items; \
 		int magic; \
 	}; \
 	\
-	int name##_add(name##_t *, int, type *); \
-	void name##_clear(name##_t *); \
-	int name##_count(name##_t *); \
-	void name##_destroy(name##_t *); \
-	void name##_exclude(name##_t *, int); \
-	void name##_exclude_index(name##_t *, int); \
-	type *name##_find(name##_t *, int); \
-	int name##_update(name##_t *, int, int); \
-	type *name##_get_index(name##_t *, int); \
-	int name##_initialize(name##_t *); \
-	int name##_is_valid(name##_t *); \
-	void name##_item_destroy(name##_item_t *); \
-	int name##_item_is_valid(name##_item_t *);
+	int name##_add(name##_ref, int, type *); \
+	void name##_clear(name##_ref); \
+	int name##_count(name##_ref); \
+	void name##_destroy(name##_ref); \
+	void name##_exclude(name##_ref, int); \
+	void name##_exclude_index(name##_ref, int); \
+	type *name##_find(name##_ref, int); \
+	int name##_update(name##_ref, int, int); \
+	type *name##_get_index(name##_ref, int); \
+	int name##_initialize(name##_ref); \
+	int name##_is_valid(name##_ref); \
+	void name##_item_destroy(name##_item_ref); \
+	int name##_item_is_valid(name##_item_ref);
 
 /** Integer to generic type map implementation.
@@ -93,10 +95,10 @@
  */
 #define INT_MAP_IMPLEMENT(name, type) \
-	int name##_add(name##_t *map, int key, type *value) \
+	int name##_add(name##_ref map, int key, type *value) \
 	{ \
 		if (name##_is_valid(map)) { \
 			if (map->next == (map->size - 1)) { \
-				name##_item_t *tmp; \
-				tmp = (name##_item_t *) realloc(map->items, \
+				name##_item_ref tmp; \
+				tmp = (name##_item_ref) realloc(map->items, \
 				    sizeof(name##_item_t) * 2 * map->size); \
 				if (!tmp) \
@@ -115,5 +117,5 @@
 	} \
 	\
-	void name##_clear(name##_t *map) \
+	void name##_clear(name##_ref map) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -130,10 +132,10 @@
 	} \
 	\
-	int name##_count(name##_t *map) \
+	int name##_count(name##_ref map) \
 	{ \
 		return name##_is_valid(map) ? map->next : -1; \
 	} \
 	\
-	void name##_destroy(name##_t *map) \
+	void name##_destroy(name##_ref map) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -150,5 +152,5 @@
 	} \
 	\
-	void name##_exclude(name##_t *map, int key) \
+	void name##_exclude(name##_ref map, int key) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -164,5 +166,5 @@
 	} \
 	\
-	void name##_exclude_index(name##_t *map, int index) \
+	void name##_exclude_index(name##_ref map, int index) \
 	{ \
 		if (name##_is_valid(map) && (index >= 0) && \
@@ -173,5 +175,5 @@
 	} \
 	\
-	type *name##_find(name##_t *map, int key) \
+	type *name##_find(name##_ref map, int key) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -187,5 +189,5 @@
 	} \
 	\
-	int name##_update(name##_t *map, int key, int new_key) \
+	int name##_update(name##_ref map, int key, int new_key) \
 	{ \
 		if (name##_is_valid(map)) { \
@@ -206,5 +208,5 @@
 	} \
 	\
-	type *name##_get_index(name##_t *map, int index) \
+	type *name##_get_index(name##_ref map, int index) \
 	{ \
 		if (name##_is_valid(map) && (index >= 0) && \
@@ -216,5 +218,5 @@
 	} \
 	\
-	int name##_initialize(name##_t *map) \
+	int name##_initialize(name##_ref map) \
 	{ \
 		if (!map) \
@@ -222,5 +224,5 @@
 		map->size = 2; \
 		map->next = 0; \
-		map->items = (name##_item_t *) malloc(sizeof(name##_item_t) * \
+		map->items = (name##_item_ref) malloc(sizeof(name##_item_t) * \
 		    map->size); \
 		if (!map->items) \
@@ -231,10 +233,10 @@
 	} \
 	\
-	int name##_is_valid(name##_t *map) \
+	int name##_is_valid(name##_ref map) \
 	{ \
 		return map && (map->magic == INT_MAP_MAGIC_VALUE); \
 	} \
 	\
-	void name##_item_destroy(name##_item_t *item) \
+	void name##_item_destroy(name##_item_ref item) \
 	{ \
 		if (name##_item_is_valid(item)) { \
@@ -247,5 +249,5 @@
 	} \
 	\
-	int name##_item_is_valid(name##_item_t *item) \
+	int name##_item_is_valid(name##_item_ref item) \
 	{ \
 		return item && (item->magic == INT_MAP_ITEM_MAGIC_VALUE); \